package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AimPlaceContentChild;
import com.izouma.awesomeadmin.service.AimPlaceContentChildService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/aimPlaceContentChild")
public class AimPlaceContentChildController {

    @Autowired
    private AimPlaceContentChildService aimPlaceContentChildService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AimPlaceContentChild record) {
        List<AimPlaceContentChild> pp = aimPlaceContentChildService.getAimPlaceContentChildList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAimPlaceContentChild", method = RequestMethod.GET)
    @ResponseBody
    public Result getAimPlaceContentChild(@RequestParam(required = false, value = "id") String id) {
        AimPlaceContentChild data = aimPlaceContentChildService.getAimPlaceContentChildById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AimPlaceContentChild record) {
        AimPlaceContentChild data = aimPlaceContentChildService.getAimPlaceContentChild(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AimPlaceContentChild record) {
        Map<String, Object> result = new HashMap<>();

        List<AimPlaceContentChild> pp =aimPlaceContentChildService.getAimPlaceContentChildByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AimPlaceContentChild record) {
        boolean num = aimPlaceContentChildService.createAimPlaceContentChild(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAimPlaceContentChild(AimPlaceContentChild record) {
        boolean num = aimPlaceContentChildService.updateAimPlaceContentChild(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAimPlaceContentChild(AimPlaceContentChild record) {

        boolean num = aimPlaceContentChildService.deleteAimPlaceContentChild(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AimPlaceContentChild record) throws Exception {

    List<AimPlaceContentChild> aimPlaceContentChilds = aimPlaceContentChildService.getAimPlaceContentChildList(record);


        String sheetName = "aim_place_content_child";
        String titleName = "目标点-内容子集数据表";
        String fileName = "目标点-内容子集表";
        int columnNumber = 14;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "目标点内容ID" ,   "类别" ,   "名称" ,   "描述" ,   "详细" ,   "备注1" ,   "备注2" ,   "备注3"  };
        String[][] dataList = new String[aimPlaceContentChilds.size()][14];

        for (int i = 0; i < aimPlaceContentChilds.size(); i++) {

                        dataList[i][0] = String.valueOf(aimPlaceContentChilds.get(i).getId());
                        dataList[i][1] = String.valueOf(aimPlaceContentChilds.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(aimPlaceContentChilds.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(aimPlaceContentChilds.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(aimPlaceContentChilds.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(aimPlaceContentChilds.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(aimPlaceContentChilds.get(i).getAimPlaceContentId());
                        dataList[i][7] = String.valueOf(aimPlaceContentChilds.get(i).getType());
                        dataList[i][8] = String.valueOf(aimPlaceContentChilds.get(i).getItemName());
                        dataList[i][9] = String.valueOf(aimPlaceContentChilds.get(i).getItemMess());
                        dataList[i][10] = String.valueOf(aimPlaceContentChilds.get(i).getItemDes());
                        dataList[i][11] = String.valueOf(aimPlaceContentChilds.get(i).getRemark1());
                        dataList[i][12] = String.valueOf(aimPlaceContentChilds.get(i).getRemark2());
                        dataList[i][13] = String.valueOf(aimPlaceContentChilds.get(i).getRemark3());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

